/* -------------------------------------------------------------------
   Fichier "four.geo"

   Ce fichier est la description geometrique utilisee par GMSH pour 
   generer le fichier "four.msh".
   ------------------------------------------------------------------- */




//                   DESCRIPTION DU FOUR
//                   -------------------

// Dimensions du Four (hauteur, Longueur, largeur en mtre)

   HauteurFour = 1.4 ; LongueurFour = 14.;  LargeurFour = 8.8 ;
   ProfondeurMarche = 1. ; LongueurMarche = 2. ;

// Paramtres maillage


  //Include "Param_maill_XXL.geo";
  //Include "Param_maill_L.geo";
  //Include "Param_maill_XL.geo";
  Include "Param_maill_test.geo";

// Description gomtrique du four

// Cration des points

   // Fond du four (partie suprieure)
 
   pf1 = newp; Point(pf1) = { LongueurFour-LongueurMarche,  LargeurFour/2.,                0., lfour};
   pf2 = newp; Point(pf2) = {                          0.,  LargeurFour/2.,                0., lfour};
   pf3 = newp; Point(pf3) = {                          0., -LargeurFour/2.,                0., lfour};
   pf4 = newp; Point(pf4) = { LongueurFour-LongueurMarche, -LargeurFour/2.,                0., lfour};

   // Fond du four (marche)

   pf5 = newp; Point(pf5) = {                LongueurFour,  LargeurFour/2., -ProfondeurMarche, lfour};
   pf6 = newp; Point(pf6) = { LongueurFour-LongueurMarche,  LargeurFour/2., -ProfondeurMarche, lfour};
   pf7 = newp; Point(pf7) = { LongueurFour-LongueurMarche, -LargeurFour/2., -ProfondeurMarche, lfour};
   pf8 = newp; Point(pf8) = {                LongueurFour, -LargeurFour/2., -ProfondeurMarche, lfour}; 

   // Dessus du four 

   pf9  = newp; Point(pf9) = { LongueurFour,  LargeurFour/2., HauteurFour, lfour};
   pf10 = newp; Point(pf10) = {           0., LargeurFour/2., HauteurFour, lfour};
   pf11 = newp; Point(pf11) = {           0.,-LargeurFour/2., HauteurFour, lfour};
   pf12 = newp; Point(pf12) = { LongueurFour,-LargeurFour/2., HauteurFour, lfour};

// Construction des artes du four

   // Artes horizontales du fond du four (partie suprieure)

   lf1 = newreg; Line(lf1) = {pf1,pf2};
   lf2 = newreg; Line(lf2) = {pf2,pf3};
   lf3 = newreg; Line(lf3) = {pf3,pf4};
   lf4 = newreg; Line(lf4) = {pf4,pf1};

   // Artes horizontales du fond de la marche

   lf5 = newreg; Line(lf5) = {pf5,pf6};
   lf6 = newreg; Line(lf6) = {pf6,pf7};
   lf7 = newreg; Line(lf7) = {pf7,pf8};
   lf8 = newreg; Line(lf8) = {pf8,pf5};

   // Artes horizontales dessus du four

   lf9  = newreg; Line(lf9)  = {pf9 ,pf10};
   lf10 = newreg; Line(lf10) = {pf10,pf11};
   lf11 = newreg; Line(lf11) = {pf11,pf12};
   lf12 = newreg; Line(lf12) = {pf12,pf9 };

   // Artes verticales du four

   lf13 = newreg; Line(lf13)  = {pf5 ,pf9};
   lf14 = newreg; Line(lf14)  = {pf6 ,pf1};
   lf15 = newreg; Line(lf15) = {pf2 ,pf10};
   lf16 = newreg; Line(lf16) = {pf3 ,pf11};
   lf17 = newreg; Line(lf17) = {pf7, pf4 };
   lf18 = newreg; Line(lf18) = {pf8, pf12};


// Dfinition des contour(s) du dessus du four

   DessusFour[0] = newreg; Line Loop(DessusFour[0]) = {lf9,lf10,lf11,lf12}; 

// Dfinitions des contours des bords du four

   // Bord en y = LargeurFour/2.

      BordFour[0] = newreg; Line Loop(BordFour[0]) = {lf5,lf14,lf1,lf15,-lf9, -lf13}; 

   // Bord en x = 0.

      BordFour[1] = newreg; Line Loop(BordFour[1]) = {lf2,lf16,-lf10,-lf15};

   // Bord en y = - LargeurFour/2.
 
      BordFour[2] = newreg; Line Loop(BordFour[2]) = {lf3,-lf17,lf7,lf18,-lf11,-lf16};

   // Bord en x = LongueurFour
 
      BordFour[3] = newreg; Line Loop(BordFour[3]) = {lf8, lf13,-lf12,-lf18}; 

// Dfinitions des contour(s) du fond du Four

   // Partie suprieure avec lectrodes

   FondFour[0] = newreg;  Line Loop(FondFour[0]) = {lf1,lf2,lf3,lf4};

   // Fond de la marche

   FondFour[1] = newreg;  Line Loop(FondFour[1]) = {lf5,lf6,lf7,lf8};

   // Paroi verticale du fond du four

   FondFour[2] = newreg;  Line Loop(FondFour[2]) = {-lf4,lf14,-lf6,-lf17};



// Discrtisation des artes du four (Nb lments / arte )

   dLF = NbElLongF + 1;
   dlF = NbElLargF + 1;
   dhF1 = NbElHautF1 + 1;
   dhF2 = NbElHautF2 + 1;
   dhF3 = NbElHautF3 + 1;

   Transfinite Line {lf1,lf3,lf9,lf11} = dLF;
   Transfinite Line {lf8,lf2,lf10,lf12} = dlF;
   Transfinite Line {lf6,lf4} = dlF;
   Transfinite Line {lf5,lf7,lf15,lf16} = dhF1;
   Transfinite Line {lf14,lf17} = dhF2;
   Transfinite Line {lf13,lf18} = dhF3;

//

//             		DESCRIPTION DES ELECTRODES
//             		--------------------------  

// 1re barrire (lectrodes 1,2,3)
// --------------------------------

   // Position du centre des lectrodes

   xc[1] =  1.5 ; yc[1] =  0.0 ; zc[1] = 0. ;
   xc[2] =  1.5 ; yc[2] =  3.5 ; zc[2] = 0. ;
   xc[3] =  1.5 ; yc[3] = -3.5 ; zc[3] = 0. ;

   // Rayon, longueur et vecteur axe des lectrodes

   For t In {1:3}

    r[t] = 0.076/2.; l[t] = 0.35 ;
    Kx[t] = 0. ; Ky[t] = 0. ; Kz[t] = 1. ; 

   EndFor 

   // Rayon, hauteur de la boite d'lectode

   R[1] = 1.  ; L[1] = 0.8 ;
   R[2] = 0.5 ; L[2] = 0.8 ;
   R[3] = 0.5 ; L[3] = 0.8 ;


// 2me barrire (lectrodes 4,5,6)
// --------------------------------

   // Position du centre des lectrodes

   xc[4] =  4. ; yc[4] =  0.0 ; zc[4] = 0. ;
   xc[5] =  4. ; yc[5] =  3.5 ; zc[5] = 0. ;
   xc[6] =  4. ; yc[6] = -3.5 ; zc[6] = 0. ;

   // Rayon, longueur et vecteur axe des lectrodes

   For t In {4:6}

    r[t] = 0.076/2.; l[t] = 0.35 ;
    Kx[t] = 0. ; Ky[t] = 0. ; Kz[t] = 1. ; 

   EndFor 

   // Rayon, hauteur de la boite d'lectode

   R[4] = 1.  ; L[4] = 0.8 ;
   R[5] = 0.5 ; L[5] = 0.8 ;
   R[6] = 0.5 ; L[6] = 0.8 ; 

// 3me barrire (lectrodes 7,8,9)
// --------------------------------

   // Position du centre des lectrodes

   xc[7] =  6.25 ; yc[7] =  0.0 ; zc[7] = 0. ;
   xc[8] =  6.25 ; yc[8] =  3.5 ; zc[8] = 0. ;
   xc[9] =  6.25 ; yc[9] = -3.5 ; zc[9] = 0. ; 

   // Rayon, longueur et vecteur axe des lectrodes

   For t In {7:9}

    r[t] = 0.076/2.; l[t] = 0.35 ;
    Kx[t] = 0. ; Ky[t] = 0. ; Kz[t] = 1. ; 

   EndFor 

   // Rayon, hauteur de la boite d'lectode

   R[7] = 1.  ; L[7] = 0.8 ;
   R[8] = 0.5 ; L[8] = 0.8 ;
   R[9] = 0.5 ; L[9] = 0.8 ; 

// 4me barrire (lectrodes 10,11,12)
// -----------------------------------

   // Position du centre des lectrodes

   xc[10] = 8.75 ; yc[10] =  0.0 ; zc[10] = 0. ;
   xc[11] = 8.75 ; yc[11] =  3.5 ; zc[11] = 0. ;
   xc[12] = 8.75 ; yc[12] = -3.5 ; zc[12] = 0. ;

   // Rayon, longueur et vecteur axe des lectrodes

   For t In {10:12}

    r[t] = 0.076/2.; l[t] = 0.35 ;
    Kx[t] = 0. ; Ky[t] = 0. ; Kz[t] = 1. ; 

   EndFor 

   // Rayon, hauteur de la boite d'lectode

   R[10] = 1.  ; L[10] = 0.8 ;
   R[11] = 0.5 ; L[11] = 0.8 ;
   R[12] = 0.5 ; L[12] = 0.8 ;  

// 5me barrire (lectrodes 13  21)
// ----------------------------------

   // Position du centre des lectrodes

   xc[13] = 11.  ; yc[13] =    0.0 ; zc[13] = 0. ;
   xc[14] = 11   ; yc[14] =    0.9 ; zc[14] = 0. ;
   xc[15] = 11   ; yc[15] =  2*0.9 ; zc[15] = 0. ;
   xc[16] = 11   ; yc[16] =  3*0.9 ; zc[16] = 0. ;
   xc[17] = 11   ; yc[17] =  4*0.9 ; zc[17] = 0. ;
   xc[18] = 11   ; yc[18] =   -0.9 ; zc[18] = 0. ;
   xc[19] = 11   ; yc[19] = -2*0.9 ; zc[19] = 0. ;
   xc[20] = 11   ; yc[20] = -3*0.9 ; zc[20] = 0. ;
   xc[21] = 11   ; yc[21] = -4*0.9 ; zc[21] = 0. ;

   // Rayon, longueur et vecteur axe des lectrodes

   For t In {13:21}

    r[t] = 0.05/2.; l[t] = 0.35 ;
    Kx[t] = 0. ; Ky[t] = 0. ; Kz[t] = 1. ; 

   EndFor 

   // Rayon, hauteur de la boite d'lectode

   For t In {13:21}

    R[t] = 0.4  ; L[t] = 0.8 ;

   EndFor   


//             		CONSTRUCTION DES ELECTRODES
//             		---------------------------

Include "Electrode_Boite.geo" ;

For t In {1:21}

   xc = xc[t] ; yc = yc[t] ; zc = zc[t] ;
   r  = r[t]  ; l = l[t] ;
   Kx = Kx[t] ; Ky = Ky[t] ; Kz = Kz[t] ;
   R = R[t]   ; L = L[t] ;

   Call Electrode ;

EndFor


//                   CONSTRUCTION DES FACES DE LA GEOMETRIE COMPLETE
//                   -----------------------------------------------


// Surface du Fond du Four - trace(s) Electrode(s)


  Plane Surface(FondFour[0]) = { FondFour[0],ContBaseBoiteElect[]};
  Plane Surface(FondFour[1]) = { FondFour[1]};
  Plane Surface(FondFour[2]) = { FondFour[2]}; 


// Surface dessus du Four - trace(s) Electrode(s)


  Plane Surface(DessusFour[0]) = {DessusFour[0]};


// Surface Bords du Four - trace(s) Electrode(s)

  Plane Surface(BordFour[0]) = { BordFour[0]};
  Plane Surface(BordFour[1]) = { BordFour[1]};
  Plane Surface(BordFour[2]) = { BordFour[2]};
  Plane Surface(BordFour[3]) = { BordFour[3]};


//                   CONSTRUCTION DES VOLUMES DE LA GEOMETRIE COMPLETE
//                   -------------------------------------------------

// Volume Verre

  FrontExtFour = newreg;
  Surface Loop(FrontExtFour) = {-FondFour[],-DessusFour[], -BordFour[]}; 

  Verre = newreg ;
//  Complex Volume(Verre) = {FrontExtFour,FrontElect[]};
//  Physical Volume(Verre) = {Verre};

  Complex Volume(Verre) = {FrontExtFour,FrontBoiteVerre[]};
  Physical Volume(Verre) = {Verre, BoiteElect[]};

// numero de la region volumique verre

//  Printf("Numero de la region vol Verre %g ", Verre) ;
  Printf("    NumRegVerre = %g ; ", Verre) ;

// Mode de connexion transformateurs - lectrodes

   Include "Connexions.geo" ;






